#!/usr/bin/python -u
# -*- coding: UTF-8 -*-

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.Label import Label
from Components.ActionMap import ActionMap
from twisted.web.client import getPage
import zipfile
from StringIO import StringIO

#    self.session.open(MessageBox, "Będe instalować !\n;-)", MessageBox.TYPE_INFO)

class DoUpdate(Screen):
    skin = """
    <screen position="240,285" size="800,150" title="Automatyczna aktualizacja wtyczki do najnowszej wersji" >
    <widget name="i1" position="10,10" size="780,30" font="Regular;20"/>
    <widget name="i2" position="10,50" size="780,90" font="Regular;20"/>
    </screen>"""
    
    def __init__(self, session, args = None):
	self.session = session
	Screen.__init__(self, session)
	self["i1"] = Label("Aktualizacja do wersji: 14.09.06")
	self["i2"] = Label("Pobieram...")
	self["myActionMap"] = ActionMap(["SetupActions"],
	{
	"cancel": self.close,
	"ok": self.close
	  }, -1)
	
	getPage('http://e2.areq.eu.org/aqtools/AQtools-14.09.06.zip').addCallback(self.zipCB).addErrback(self.errorCB)

    def errorCB(self, html = ''):
	self["i2"].setText("Problem z pobraniem aktualizacji, sprobuj pozniej")

    def zipCB(self, html):
        if len(html) > 100:
	    z = zipfile.ZipFile(StringIO( html ))
	    z.extractall('/usr/lib/enigma2/python/Plugins/Extensions/')
	    self["i2"].setText("Aktualizacja zakonczona ;) \nUruchom ponownie plugin, byc moze restart GUI enigma2 nie bedzie konieczny.")
#	    self["i2"].setText("Aktualizacja zakonczona ;) \nWykonaj restart GUI enigma2.")
	else:
	    self["i2"].setText("Problem z instalacja aktualizacji, sprobuj pozniej")
